#include "ARN.c"

int main(){

	//--- test de cree_feuille 
	arn a_test = cree_feuille (12,"douze");
	assert (a_test->cle == 12);
	
	//--- test de est_valide (inclu est_vide et est_feuille) 
	assert (est_valide(a_test));
	
	//--- test de rotation sans pere
	arn a_uv = cree_feuille(20,"u");
	a_uv->fg = cree_feuille(10,"v");
	assert(est_valide(a_uv) && a_uv->cle == 20 && a_uv->fg->cle == 10);
	rotation_ptr(a_uv, a_uv->fg, gauche, &a_uv);
	assert(est_valide(a_uv) && a_uv->cle == 10 && a_uv->fd->cle == 20);
	rotation_ptr(a_uv, a_uv->fd, droite, &a_uv);
	assert(est_valide(a_uv) && a_uv->cle == 20 && a_uv->fg->cle == 10);
	
	a_uv->fd = cree_feuille(30,"w");
	assert(est_valide(a_uv) && a_uv->fd->cle == 30);
	rotation_ptr(a_uv, a_uv->fd, droite, &a_uv);
	assert(a_uv->cle==30 && a_uv->fg->cle==20 && a_uv->fg->fg->cle==10 );
	rotation_ptr(a_uv, a_uv->fg, gauche, &a_uv);
	assert(est_valide(a_uv) && a_uv->cle == 20);
	assert(a_uv->fg->cle == 10 && a_uv->fd->cle == 30);
	rotation_ptr(a_uv, a_uv->fg, gauche, &a_uv);
	assert(a_uv->cle==10 && a_uv->fd->cle==20 && a_uv->fd->fd->cle==30 );
	
	//--- test de rotation_pere
	//-- rotation de l'arête 20\30
	rotation_pere(a_uv->fd, a_uv->fd->fd, droite,a_uv, droite);
	assert(a_uv->cle==10 && a_uv->fd->cle==30 && a_uv->fd->fg->cle==20 );
	a_uv->fd->fg->fg = cree_feuille(15,"x");
	a_uv->fd->fg->fd = cree_feuille(25,"y");
	//-- rotation de l'arête 15/20
	rotation_pere(a_uv->fd->fg, a_uv->fd->fg->fg,gauche,a_uv->fd, gauche);
	assert(a_uv->cle == 10 && a_uv->fd->cle == 30);
	assert(a_uv->fd->fg->cle ==15);
	assert (a_uv->fd->fg->fd->cle==20 && a_uv->fd->fg->fd->fd->cle==25);
	
	
	//--- test de scission à la racine
	arn abc = cree_feuille(2,"b");
	abc->fg = cree_feuille(1,"a");
	abc->fg->rg = true;
	abc->fd = cree_feuille(3,"c");
	abc->fd->rg = true;
	scinde_ptr(abc,NULL,gauche,NULL,gauche,NULL);
	assert (abc->cle == 2 && abc->fg->cle==1 && abc->fd->cle==3);
	assert(!abc->rg && !abc->fg->rg && !abc->fd->rg);
	
	//--- test de scission dans l'arbre inclu dans l'insertion
	
	//---test d'insertion
	arn a12 = NULL;
	insere(&a12,12,"douze");
	assert (est_valide(a12));
	assert (a12->cle == 12);
	
	insere(&a12,13,"treize");
	assert (est_valide(a12));
	assert (a12->cle == 12 && a12->fd->cle == 13 && a12->fd->rg);
	
	insere(&a12,14,"quatorze");
	assert (est_valide(a12));
	assert (a12->cle == 13 && a12->fg->cle == 12 && a12->fd->cle == 14);
	
	insere (&a12,15,"quinze");
	assert (est_valide(a12) );
	assert(a12->fd->fd->cle == 15 &&  a12->fd->fd->rg );
	assert (a12->cle == 13 && a12->fg->cle == 12 && a12->fd->cle == 14);
	assert (est_valide(a12));
	
	insere (&a12,16,"seize");
	assert (a12->cle == 13 && a12->fg->cle == 12 && a12->fd->cle == 15);
	assert(a12->fd->fg->cle == 14 && a12->fd->fd->cle == 16);
	assert (est_valide(a12));
	
	insere (&a12,10,"dix");
	assert (a12->cle == 13 && a12->fg->cle == 12 && a12->fd->cle == 15);
	assert(a12->fd->fg->cle == 14 && a12->fd->fd->cle == 16);
	assert(a12->fg->fg->cle == 10 &&  a12->fg->fg->rg );
	assert (est_valide(a12));
	
	insere (&a12,11,"onze");
	assert (a12->cle == 13 && a12->fd->cle == 15);
	printf("a12->fg->cle = %d \n",a12->fg->cle);
	assert (a12->fg->cle == 11);
	assert(a12->fd->fg->cle == 14 && a12->fd->fd->cle == 16);
	assert(a12->fg->fg->cle == 10 &&  a12->fg->fd->cle ==12 );
	
	insere (&a12,1,"un");
	insere (&a12,18,"dix-huit");
	insere (&a12,23,"vingt-trois");
	assert (est_valide(a12));
	
	//--- test insertion (cas d'une rotation double sans père)
	arn a8 = NULL;
	insere(&a8,8,"huit");
	insere(&a8,11,"onze");
	insere(&a8,9,"neuf");
	assert(a8->cle == 9 && a8->fg->cle == 8 && a8->fd->cle == 11);
	assert(a8->fg->rg && a8->fd->rg);
	insere(&a8,10,"dix");
	assert(a8->cle == 9 && a8->fg->cle == 8 && a8->fd->cle == 11);
	assert(!a8->fg->rg && !a8->fd->rg);
	assert( a8->fd->fg->cle == 10 && a8->fd->fg->rg);
	
	//--- test de recherche
	printf("%d s'écrit %s\n", 10, cherche_cle(a12,10));
	printf("%d s'écrit %s\n", 11, cherche_cle(a12,11));
	printf("%d s'écrit %s\n", 12, cherche_cle(a12,12));
	printf("%d s'écrit %s\n", 13, cherche_cle(a12,13));
	printf("%d s'écrit %s\n", 14, cherche_cle(a12,14));
	printf("%d s'écrit %s\n", 15, cherche_cle(a12,15));
	printf("%d s'écrit %s\n", 16, cherche_cle(a12,16));
	
	printf("%d s'écrit %s\n", 18, cherche_cle(a12,18));
	printf("%d s'écrit %s\n", 1, cherche_cle(a12,1));
	printf("%d s'écrit %s\n", 23, cherche_cle(a12,23));
	
	//--- libérer l'espace mémoire
	supprime_arn(a12);
	supprime_arn(a8);
	supprime_arn(abc);
	supprime_arn(a_test);
	return 0;

}
